Bug 50488 (Calc-Function-missingODFF1.2) - [META] several functions defined in ODFF1.2 are not available in calc
Summary: [META] several functions defined in ODFF1.2 are not available in calc
Status: RESOLVED FIXED
Alias: Calc-Function-missingODFF1.2
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
3.6.1.1 rc
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: odf target:5.3.0
Keywords:
Depends on: 50882 50950 51017 56124 57180 60322 100749 107135
Blocks: ODF-import Calc-Function
  Show dependency treegraph
 
Reported: 2012-05-29 23:14 UTC by Winfried Donkers
Modified: 2018-09-23 18:51 UTC (History)
8 users (show)

See Also:
Crash report or crash signature:


Attachments
diff files of changes for ISOWEEKNUM so far - not yet ready for pushing to git (9.86 KB, patch)
2012-06-01 08:11 UTC, Winfried Donkers
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Winfried Donkers 2012-05-29 23:14:06 UTC
The following functions are defined in ODFF1.2, but not available in calc:
(SMALL Group:)
AVERAGEIF 6.18.5 ; -handled in bug 41214

(MEDIUM Group:)
COUPDAYBS 6.12.5 ; 
COUPDAYS 6.12.6 ; 
COUPDAYSNC 6.12.7 ; 
COUPNCD 6.12.7 ; 
COUPNUM 6.12.9 ; 
COUPPCD 6.12.10 ; 
EFFECT 6.12.19 ; 
ISOWEEKNUM 6.10.11 ; 
LEGACY.CHIDIST 6.18.11 ; 
LEGACY.CHIINV 6.18.13 ; 
LEGACY.CHITEST 6.18.15 ; 
LEGACY.FDIST 6.18.23 ; 
LEGACY.FINV 6.18.25 ; L
LEGACY.NORMSDIST 6.18.54 ; 
LEGACY.NORMSINV 6.18.55 ; 
LEGACY.TDIST 6.18.77 ; 
SKEWP 6.18.68 ; 

(LARGE Group:)
AVERAGEIFS 6.18.6 ; -handled in bug 41214
BINOM.DIST.RANGE 6.18.9 ; 
COUNTIFS 6.13.10 ;-handled in bug 41214
FINDB 6.7.2 ; 
IFERROR 6.15.5 ; 
IFNA 6.15.6 ; 
IMCOT 6.8.9 ; 
IMCSC 6.8.10 ; 
IMCSCH 6.8.11 ; 
IMSEC 6.8.22 ; 
IMSECH 6.8.23 ; 
IMTAN 6.8.27; 
LEFTB 6.7.3 ; 
LENB 6.7.4 ; 
MIDB 6.7.5 ; 
MINA 6.18.49 ; 
MULTIPLE.OPERATIONS 6.14.10 ; 
NUMBERVALUE 6.13.28 ; 
PDURATION 6.12.35 ; 
REPLACEB 6.7.6 ; 
RIGHTB 6.7.7 ; 
SEARCHB 6.7.8 ; 
SUMIFS 6.16.63 ; -handled in bug 41214
XOR 6.15.10
Comment 1 Winfried Donkers 2012-05-29 23:18:20 UTC
I intend to start with ISOWEEKNUM and XOR.
Comment 2 Winfried Donkers 2012-06-01 08:11:35 UTC
Created attachment 62380 [details]
diff files of changes for ISOWEEKNUM so far - not yet ready for pushing to git

The function ISOWEEKNUM I made, works fine (see diff attachment), but there is a snatch:

the current WEEKNUM function, which behaves not conform ODFF 1.2, is stored in the file as ISOWEEKNUM...
This means that there are some problems:
-WEEKNUM should (IMHO) behave as defined in ODFF1.2;
-use of WEEKNUM should be saved as WEEKNUM, making the use (and saving) of ISOWEEKNUM possible;
-compatibility with previously saved files must be achieved. WEEKNUM has 2 paramters, ISOWEEKNUM only 1. I have no experience with function overloading when reading/saving files;
-compatibility with older version of LibreOffice that want to open a spreadsheet file using WEEKNUM that was saved by a newer version of LibreOffice (that supports ISOWEEKNUM).

Any suggestion is more than welcome!

In the mean time I will start on function XOR.
Comment 3 Winfried Donkers 2012-06-07 00:29:30 UTC
(In reply to comment #2)

After communication with Eike, I will make WEEKNUM to comply strictly with ODFF1.2 and add ISOWEEKNUM (also strictly complying with ODFF1.2, of course)
Comment 4 Winfried Donkers 2012-06-08 08:00:53 UTC
created bug 50882 for function XOR
Comment 5 Winfried Donkers 2012-06-11 04:19:40 UTC
created bug 50959 for ODFF functions WEEKNUM/ISOWEEKNUM
Comment 6 Eike Rathke 2012-06-11 08:00:21 UTC
(In reply to comment #5)
> created bug 50959 for ODFF functions WEEKNUM/ISOWEEKNUM

That's bug 50950 instead.
Comment 7 Eike Rathke 2012-06-12 14:29:54 UTC
Created bug 51017 for IMTAN, IMSEC, IMCSC, IMCOT, IMSINH, IMCOSH, IMSECH, IMCSCH.
Comment 8 Michael Stahl (CIB) 2012-07-05 05:49:08 UTC
Comment on attachment 62380 [details]
diff files of changes for ISOWEEKNUM so far - not yet ready for pushing to git

it looks like this patch is obsoleted by the one at bug 50950.
Comment 9 Winfried Donkers 2012-07-05 23:27:49 UTC
(In reply to comment #8)
> it looks like this patch is obsoleted by the one at bug 50950.

You are correct. This bug will no longer have patches/diff files as attachment, as for each calc function a separate bug will be created (such as 50950).
Comment 10 Winfried Donkers 2012-10-08 09:11:26 UTC
@Eike:
I intend to open a new bug for implementing FINDB, LETFB, LENB, MIDB, REPLACEB, RIGHTB, SEARCHB and start working on these functions.
Any objections? Or do you prefer me to work on other functions first?
Comment 11 Eike Rathke 2012-10-11 16:05:45 UTC
@Winfried:
AOO recently implemented at least LEFTB, RIGHTB, MIDB and LENB so we could cherry-pick that after we rebased formula and sc to AOO with ALv2 license. Hopefully they'll also implement the other *B functions. Anyhow, those functions probably are rarely used and we can concentrate or more important ones.

The most needed functions would be IFERROR and IFNA, but also one of the hardest to implement. If you'd like to that a look at that?
Comment 12 Winfried Donkers 2012-10-12 09:37:54 UTC
(In reply to comment #11)
@Eike:

I will have a look at IFERROR and IFNA. If I see possibilities, I will open a seperate bug and put you in cc.
Comment 13 Winfried Donkers 2013-02-11 08:29:23 UTC
@Eike:

It seems we've reached the end of the list:
all functions seem to be present, except
-(ISO)WEEKNUM which has a patch in bug 50950, but needs fiddling for compatibility with older version, which is beyond my capabilities;
-FINDB, LEFTB, LENB, MIDB, REPLACEB, RIGHTB, SEARCHB which seem to be in a coming AOOo packet.

Do you still see functions to be implemented yet?
If not, I will search for other calc-work waiting to be done. You can always ask me if you have something that needs working on.

Thank you very much for your help and patience!
Comment 14 zaxebo zaxebo 2014-11-25 20:01:00 UTC
@Winfried Donkers:
ENCODEURL() function is missing , please refer
https://bugs.freedesktop.org/show_bug.cgi?id=76870
Comment 15 zaxebo zaxebo 2015-02-03 15:45:33 UTC
update:

among the list of functions given in Comment13(made in Feb-2013), the following functions are still NOT available in libreoffice 4.4
   PDURATION()
   REPLACEB()
Comment 16 zaxebo zaxebo 2015-02-03 15:48:46 UTC
SEARCHB()
FINDB()
are also NOT available in libreoffice 4.4 yet
Comment 17 Eike Rathke 2015-02-04 13:56:33 UTC
Note that PDURATION() was always available as DURATION() in the UI, and DURATION() as DURATION_ADD(). Yes, it is confusing and should be changed.
Comment 18 Commit Notification 2016-08-03 15:10:13 UTC
Eike Rathke committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=dbbab7b1b0c2c1c43cc52b620212fb29c7b99bff

UI rename DURATION to PDURATION, DURATION_ADD to DURATION, tdf#50488 related

It will be available in 5.3.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 19 Xisco Faulí 2017-07-14 13:25:46 UTC
Polite ping: is this bug fixed? if so, please close it as RESOLVED FIXED
Comment 20 Dennis Roczek 2017-07-14 14:26:54 UTC
Hi Xisco,

no, see the depending issues (this is somehow a meta issue) + list at https://wiki.documentfoundation.org/Development/Calc/Spreadsheet_Functions/not_yet_implemented

Regards,

Dennis
Comment 21 Winfried Donkers 2017-12-08 16:34:42 UTC
AFAIK all functions defined in ODFF1.2 are implemented in Calc. There are some Microsoft Excel and Apple Numbers functions that currently are not implemented, but this bug report is about ODFF1.2 functions.